#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"

#include "sys/alt_irq.h"

#include "7SEG.h"
#include "KBD.h"
#include "UART.h"
#include "cli.h"

void timer0Interrupt(void* context){
	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE, 0);
	refreshDisplay();
}

void commandHELP(char *args) {
	CLI_PrintAllCommands();
}
CLI_CommandItem item_HELP = { 	.callback = commandHELP,
								.commandName = "?",
								.description = "\tDisplay this help."};

void commandSET(char *args) {
	char textBuffer[20];
	uint16_t value = atoi(args);
	intDisplayDec(value);
	sprintf(textBuffer, "Value=%d\r\n", value);
	UART_WriteString(textBuffer);
}
CLI_CommandItem item_SET = { 	.callback = commandSET,
								.commandName = "S",
								.description = "\tSet display."};

int main()
{ 

  alt_ic_isr_register(TIMER0_IRQ_INTERRUPT_CONTROLLER_ID, TIMER0_IRQ, timer0Interrupt, NULL, NULL);

  //UART_SetBaud(500000);

  IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER0_BASE, ALTERA_AVALON_TIMER_CONTROL_START_MSK |
  	ALTERA_AVALON_TIMER_CONTROL_CONT_MSK | ALTERA_AVALON_TIMER_CONTROL_ITO_MSK );

  UART_Init();

  uint16_t i = 0;
  intDisplayDec(i);

  CLI_AddCommand(&item_HELP);
  CLI_AddCommand(&item_SET);

  /* Event loop never exits. */
  while (1){
	  CLI_Proc();
  }

  return 0;
}
