#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "altera_avalon_spi_regs.h"
#include "altera_avalon_spi.h"

#include "mcp23x08.h"
#include "mcp23x08_regs.h"

uint8_t spiWriteData[3];
uint8_t spiReadData[1];

void MCP23X08writeReg(uint8_t cs, uint8_t reg, uint8_t val){
	spiWriteData[0] = MCP23x08_ADDR | MCP23x08_SPI_W;
	spiWriteData[1] = reg;
	spiWriteData[2] = val;
	alt_avalon_spi_command(SPI_5V_BASE, cs, 3, spiWriteData, 0, spiReadData, 0);
}

uint8_t MCP23X08readReg(uint8_t cs, uint8_t reg){
	spiWriteData[0] = MCP23x08_ADDR | MCP23x08_SPI_R;
	spiWriteData[1] = reg;
	alt_avalon_spi_command(SPI_5V_BASE, cs, 2, spiWriteData, 1, spiReadData, 0);
	return spiReadData[0];
}
