#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"

#include "i2c.h"

#include "mcp23x08.h"
#include "mcp23x08_regs.h"

void MCP23X08writeReg(uint8_t addr, uint8_t reg, uint8_t val){
	i2cWrite(I2C_BASE, I2C_START, MCP23x08_ADDR | ((addr & 0b111)<<1) | I2C_W);
	i2cWrite(I2C_BASE, I2C_NORM, reg);
	i2cWrite(I2C_BASE, I2C_STOP, val);
}

uint8_t MCP23X08readReg(uint8_t addr, uint8_t reg){
	i2cWrite(I2C_BASE, I2C_START, MCP23x08_ADDR | ((addr & 0b111)<<1) | I2C_W);
	i2cWrite(I2C_BASE, I2C_NORM, reg);
	i2cWrite(I2C_BASE, I2C_START, MCP23x08_ADDR | ((addr & 0b111)<<1) | I2C_R);
	return i2cRead(I2C_BASE, I2C_STOP);
}
