#include "adc.h"

#include "system.h"
#include "altera_modular_adc.h"

void adcInitSingle(void){
	adc_stop(ADC_SEQUENCER_CSR_BASE);
	adc_interrupt_disable(ADC_SAMPLE_STORE_CSR_BASE);
	adc_clear_interrupt_status(ADC_SAMPLE_STORE_CSR_BASE);
	adc_set_mode_run_once(ADC_SEQUENCER_CSR_BASE);
}

void adcReadSingle(uint32_t* source_ptr, uint32_t len){
	adc_start(ADC_SEQUENCER_CSR_BASE);
	adc_wait_for_interrupt(ADC_SAMPLE_STORE_CSR_BASE);
	adc_clear_interrupt_status(ADC_SAMPLE_STORE_CSR_BASE);
	alt_adc_word_read(ADC_SAMPLE_STORE_CSR_BASE, source_ptr, len);
	adc_stop(ADC_SEQUENCER_CSR_BASE);
}

void adcInitCont(void){
	adc_stop(ADC_SEQUENCER_CSR_BASE);
	adc_interrupt_disable(ADC_SAMPLE_STORE_CSR_BASE);
	adc_clear_interrupt_status(ADC_SAMPLE_STORE_CSR_BASE);
	adc_set_mode_run_continuously(ADC_SEQUENCER_CSR_BASE);
	adc_start(ADC_SEQUENCER_CSR_BASE);
}

void adcReadCont(uint32_t* source_ptr, uint32_t len){
	adc_wait_for_interrupt(ADC_SAMPLE_STORE_CSR_BASE);
	adc_clear_interrupt_status(ADC_SAMPLE_STORE_CSR_BASE);
	alt_adc_word_read(ADC_SAMPLE_STORE_CSR_BASE, source_ptr, len);
}

uint32_t adcVoltage(uint32_t adcValue){
	return adcValue * 250000 / 4095;
}
