#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"

#include "adc.h"

int32_t calculateTemp(uint32_t voltage){
	return ((186630 - voltage) * 10) / 1169;
}

int main()
{ 
	alt_putstr("T [*C]\r\n");

	adcInitSingle();

	uint32_t adcData[2];

	while (1){
		int32_t temp = 0;
		for(int i = 0 ; i < 100 ; i++){
			adcReadSingle(adcData, 2);
			temp += adcData[1];
		}
		temp /= 100;
		temp = adcVoltage(temp);
		temp = calculateTemp(temp);

		printf("%lu.%d\r\n", temp/10, abs(temp)%10);

		ALT_USLEEP(100000);
	}

	return 0;
}
