-- tutorial_ws2812_0.vhd

-- Generated using ACDS version 18.1 625

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity tutorial_ws2812_0 is
	generic (
		NUM_DIODES : integer := 2;
		ADDRBITS   : integer := 3
	);
	port (
		clk        : in  std_logic                     := '0';             --          clock.clk
		reset_n    : in  std_logic                     := '0';             --          reset.reset_n
		address    : in  std_logic_vector(2 downto 0)  := (others => '0'); -- avalon_slave_0.address
		byteenable : in  std_logic_vector(3 downto 0)  := (others => '0'); --               .byteenable
		read       : in  std_logic                     := '0';             --               .read
		readdata   : out std_logic_vector(31 downto 0);                    --               .readdata
		write      : in  std_logic                     := '0';             --               .write
		writedata  : in  std_logic_vector(31 downto 0) := (others => '0'); --               .writedata
		led_out    : out std_logic                                         --        led_out.led_out
	);
end entity tutorial_ws2812_0;

architecture rtl of tutorial_ws2812_0 is
	component WS2812 is
		generic (
			NUM_DIODES : integer := 2;
			ADDRBITS   : integer := 3
		);
		port (
			clk        : in  std_logic                     := 'X';             -- clk
			reset_n    : in  std_logic                     := 'X';             -- reset_n
			address    : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- address
			byteenable : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			read       : in  std_logic                     := 'X';             -- read
			readdata   : out std_logic_vector(31 downto 0);                    -- readdata
			write      : in  std_logic                     := 'X';             -- write
			writedata  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			led_out    : out std_logic                                         -- led_out
		);
	end component WS2812;

begin

	num_diodes_check : if NUM_DIODES /= 2 generate
		assert false report "Supplied generics do not match expected generics" severity Failure;
	end generate;

	addrbits_check : if ADDRBITS /= 3 generate
		assert false report "Supplied generics do not match expected generics" severity Failure;
	end generate;

	ws2812_0 : component WS2812
		generic map (
			NUM_DIODES => 2,
			ADDRBITS   => 3
		)
		port map (
			clk        => clk,        --          clock.clk
			reset_n    => reset_n,    --          reset.reset_n
			address    => address,    -- avalon_slave_0.address
			byteenable => byteenable, --               .byteenable
			read       => read,       --               .read
			readdata   => readdata,   --               .readdata
			write      => write,      --               .write
			writedata  => writedata,  --               .writedata
			led_out    => led_out     --        led_out.led_out
		);

end architecture rtl; -- of tutorial_ws2812_0
