-- Project:			maximator-Tutorial-15
-- File:				top.vhd
-- Version:			1.0 (12.01.2019)
-- Author:			Top module for NIOS II Ecosystem

library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

entity top is
	port (
		clk_clk       : in  std_logic;
		led_export    : out std_logic_vector(3 downto 0);
		reset_reset_n : in  std_logic
	);
end top;

architecture Basic of top is
	component tutorial is
		port (
			clk_clk       : in  std_logic                    := 'X'; -- clk
			led_export    : out std_logic_vector(3 downto 0);        -- export
			reset_reset_n : in  std_logic                    := 'X'  -- reset_n
		);
	end component tutorial;
 
	signal led_inverted : std_logic_vector(3 downto 0);
begin

	led_export <= not led_inverted;
    

	u0 : component tutorial
		port map (
			clk_clk       => clk_clk,       --   clk.clk
			led_export    => led_inverted,    --   led.export
			reset_reset_n => reset_reset_n  -- reset.reset_n
		);


end basic;
